SystemOrganization addCategory: #MudTalk!
SystemOrganization addCategory: #'MudTalk-Client'!
SystemOrganization addCategory: #'MudTalk-Tests'!

Object subclass: #MudServer
	instanceVariableNames: 'started'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!MudServer methodsFor: 'initialize-release' stamp: 'AlexanderSvyazin 10/12/2012 23:23'!
initialize
	started := false.! !

!MudServer methodsFor: 'state' stamp: 'AlexanderSvyazin 10/12/2012 23:23'!
isStarted
	^ started.! !

!MudServer methodsFor: 'state' stamp: 'AlexanderSvyazin 10/12/2012 23:21'!
isStopped
	^ started not.! !

!MudServer methodsFor: 'start-stop' stamp: 'AlexanderSvyazin 10/12/2012 23:32'!
start
	started := true.! !

!MudServer methodsFor: 'start-stop' stamp: 'AlexanderSvyazin 10/12/2012 23:33'!
stop
	started := false.! !

Object subclass: #MudTalkClient
	instanceVariableNames: 'window inputPane outputPane outputContents connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Client'!

!MudTalkClient methodsFor: 'connection' stamp: 'AlexanderSvyazin 1/2/2013 18:17'!
connectTo: aHost port: aPort 
	connection := MudTalkClientConnection new connectTo: aHost port: aPort.! !

!MudTalkClient methodsFor: 'connection' stamp: 'AlexanderSvyazin 1/2/2013 20:49'!
disconnect
	connection ifNotNil: [ connection terminate ].! !

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/2/2013 17:48'!
getInput
	^nil.! !

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/2/2013 18:10'!
host
	^ NetNameResolver addressFromString: '10.240.1.10'.! !

!MudTalkClient methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/2/2013 19:59'!
initialize
	super initialize.
	self installInputPane.
	self installOutputPane.
	self initializeConnection.
	self window openInWorld.
	self inputPane takeKeyboardFocus.! !

!MudTalkClient methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/2/2013 21:13'!
initializeConnection
	self connectTo: self host port: self port.
	connection events when: #textReceived send: #textReceived: to: self! !

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/2/2013 18:20'!
inputPane
	^ inputPane ifNil: [
		inputPane := self window newTextEditorFor: self getText: #getInput setText: #sendCommand:.
		inputPane acceptOnCR: true].! !

!MudTalkClient methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/2/2013 17:02'!
installInputPane
	self window
		addMorph: self inputPane
		fullFrame: (LayoutFrame fractions: (0@0.5 extent: 1@1)).! !

!MudTalkClient methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/2/2013 17:04'!
installOutputPane
	self window
		addMorph: self outputPane
		fullFrame: (LayoutFrame fractions: (0@0 extent: 1@0.5)).! !

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/2/2013 17:39'!
outputContents
	^ outputContents ifNil: [
		outputContents := Text new].! !

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/2/2013 17:39'!
outputPane
	^ outputPane ifNil: [
		outputPane := self window newTextEditorFor: self getText: #outputContents setText: nil].! !

!MudTalkClient methodsFor: 'outputting' stamp: 'AlexanderSvyazin 1/2/2013 17:52'!
outputText: aText
	self outputContents append: aText.
	self outputContents append: Character cr.
	self changed: #outputContents.! !

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/2/2013 18:05'!
port
	^ 10101.! !

!MudTalkClient methodsFor: 'updating' stamp: 'AlexanderSvyazin 1/2/2013 21:14'!
sendCommand: aText
	connection sendText: aText.
	self changed: #getInput.! !

!MudTalkClient methodsFor: 'connection' stamp: 'AlexanderSvyazin 1/2/2013 21:12'!
textReceived: line 
	self outputText: line asText.! !

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/2/2013 16:34'!
window
	^ window ifNil: [
		window := StandardWindow labelled: 'MUD client']! !

Object subclass: #MudTalkClientConnection
	instanceVariableNames: 'stream readingProcess events'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Client'!

!MudTalkClientConnection methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/2/2013 20:48'!
connectTo: aHost port: aPort 
	stream := SocketStream openConnectionToHost: aHost port: aPort.
	readingProcess := [self networkReadLoop] forkNamed: 'MUD client network reading process'.! !

!MudTalkClientConnection methodsFor: 'events' stamp: 'AlexanderSvyazin 1/2/2013 20:58'!
events
	^ events ifNil: [
		events := EventManager new].! !

!MudTalkClientConnection methodsFor: 'read' stamp: 'AlexanderSvyazin 1/2/2013 20:46'!
networkReadLoop
	[self processLineFromServer] repeat.! !

!MudTalkClientConnection methodsFor: 'read' stamp: 'AlexanderSvyazin 1/2/2013 21:11'!
processLineFromServer
	|line|
	line := stream nextLine.
	self events triggerEvent: #textReceived with: line.! !

!MudTalkClientConnection methodsFor: 'write' stamp: 'AlexanderSvyazin 1/2/2013 21:19'!
sendText: aText
	stream nextPutAll: aText; crlf; flush.! !

!MudTalkClientConnection methodsFor: 'read' stamp: 'AlexanderSvyazin 1/2/2013 20:49'!
terminateReadingProcess
	readingProcess ifNotNil: [ readingProcess terminate ]! !

TestCase subclass: #MudServerTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Tests'!

!MudServerTests methodsFor: 'tests' stamp: 'AlexanderSvyazin 10/16/2012 23:22'!
testStartStop
	|server|
	server := MudServer new.
	server start.
	self should: [server isStarted].
	self shouldnt: [server isStopped].
	server stop.
	self should: [server isStopped].
	self shouldnt: [server isStarted].! !

!MudServerTests methodsFor: 'tests' stamp: 'AlexanderSvyazin 10/12/2012 23:20'!
testState
	|server|
	server := MudServer new.
	self should: [server isStopped].
	self shouldnt: [server isStarted].! !
